<?php
/**
 * copyright (C) 2008 GWE Systems Ltd - All rights reserved
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

/**
 * HTML View class for the component frontend
 *
 * @static
 */
include(dirname(__FILE__)."/../default/calendar.php");


class ExtModCalView extends DefaultModCalView 
{
	
	function _displayCalendarMod($time, $startday, $linkString,	&$day_name, $monthMustHaveEvent=false){
			global  $mainframe;
			$db	=& JFactory::getDBO();
			$cfg = & JEVConfig::getInstance();
			$compname = JEV_COM_COMPONENT;

			$cal_day=date("d",$time);
			$cal_year=date("Y",$time);
			$cal_month=date("m",$time);
			$calmonth=date("n",$time);
			$data = $this->datamodel->getCalendarData($cal_year,$cal_month,1,true,$this->modcatids,$this->catidList, $this->myItemid);

			$month_name = JEVHelper::getMonthName($cal_month);
			$to_day     = date("Y-m-d", $this->timeWithOffset);
			$today = mktime(0,0,0,$cal_month, $cal_day, $cal_year);

			$cal_prev_month 	= $cal_month - 1;
			$cal_next_month 	= $cal_month + 1;
			$cal_next_month_year	= $cal_year;
			$cal_prev_month_year	= $cal_year;

			// additional EBS
			if( $cal_prev_month == 0 ) {
				$cal_prev_month 	= 12;
				$cal_prev_month_year 	-=1;
			}
			if( $cal_next_month == 13 ) {
				$cal_next_month 	= 1;
				$cal_next_month_year 	+=1;
			}

			$linkpref = "index.php?option=$compname&Itemid=".$this->myItemid.$this->cat."&task=";
			$linkprevious = $linkpref."month.calendar&day=$cal_day&month=$cal_prev_month&year=$cal_prev_month_year";
			$linkprevious = JRoute::_($linkprevious);
			$linkcurrent = $linkpref."month.calendar&day=$cal_day&month=$cal_month&year=$cal_year";
			$linkcurrent = JRoute::_($linkcurrent);
			$linknext = $linkpref."month.calendar&day=$cal_day&month=$cal_next_month&year=$cal_next_month_year";
			$linknext = JRoute::_($linknext);

			$viewname = $this->getTheme();
			$viewpath = JURI::root() . "components/$compname/views/".$viewname."/assets";
			$viewimages = $viewpath . "/images";

			$content = <<<START
<div id="extcal_minical">
	<table cellspacing="1" cellpadding="0" border="0" align="center" style="border: 1px solid rgb(190, 194, 195); background-color: rgb(255, 255, 255);">
		<tr>
			<td>
				<table width="100%" cellspacing="0" cellpadding="2" border="0" class="extcal_navbar">
					<tr>
						<td valign="middle" height="18" align="center">
							<a href="$linkprevious">
                    		<img border="0" title="previous month" alt="previous month" src="$viewimages/mini_arrowleft.gif"/ >
                  			</a>
                		</td>
		                <td width="98%" valign="middle" nowrap="nowrap" height="18" align="center" class="extcal_month_label">
							<a href="$linkcurrent" style="text-decoration:none;color:inherit;">
		                	$month_name $cal_year
							</a>
		                </td>
						<td valign="middle" height="18" align="center">
		                    <a href="$linknext">
		                    <img border="0" title="next month" alt="next month" src="$viewimages/mini_arrowright.gif" />
        					</a>
                		</td>
					</tr>
				</table>
				<table class="extcal_weekdays">
START;
			$lf="\n";


			// Days name rows - with blank week no.
			$content	.= "<tr>\n<td/>\n";
			for ($i=0;$i<7;$i++) {
				$content.="<td  class='extcal_weekdays'>".$day_name[($i+$startday)%7]."</td>".$lf	;
			}
			$content.="</tr>\n";

			$datacount = count($data["dates"]);
			$dn=0;
			for ($w=0;$w<6 && $dn<$datacount;$w++){
				$content .="<tr>\n";
				// the week column
				list($week,$link) = each($data['weeks']);
				$content .= '<td class="extcal_weekcell">';
				$content .= "<a href='".$link."'><img width='5' height='20' border='0' alt='week ".$week."' src='".$viewimages."/icon-mini-week.gif'/></a></td>\n";

				for ($d=0;$d<7 && $dn<$datacount;$d++){
					$currentDay = $data["dates"][$dn];
					switch ($currentDay["monthType"]){
						case "prior":
						case "following":
							$content .= "<td class='extcal_othermonth'/>\n";
							break;
						case "current":

							$dayOfWeek=strftime("%w",$currentDay["cellDate"]);

							$class = ($currentDay["today"]) ? "extcal_todaycell" : "extcal_daycell";
							$linkclass = "extcal_daylink";
							if($dayOfWeek==0 && !$currentDay["today"]) {
								$class = "extcal_sundaycell";
								$linkclass = "extcal_sundaylink";
							}

							if ($currentDay["events"]) {
								$linkclass = "extcal_busylink";
							}
							$content .= "<td class='".$class."'>\n";
							$content .="<a class='".$linkclass."' href='".$currentDay["link"]."' title='". JText::_('JEV_CLICK_TOSWITCH_DAY')."'>". $currentDay['d']."</a>\n";

							$content .="</td>\n";
							break;

					}
					$dn++;
				}
				$content .="</tr>\n";
			}
			$content .= "</table>\n";
			$content .= "</td></tr></table></div>\n";

			// Now check to see if this month needs to have at least 1 event in order to display
//			if (!$monthMustHaveEvent || $monthHasEvent) return $content;
//			else return '';
			return $content;
		}
	
}
